#!/usr/bin/env bash

set -o nounset

curl "https://git.sovransystems.com/Sovran_Systems/Software/raw/branch/main/Sovran_SystemsOS_Updater/Updater%20Source%20Files/Intro.md" |
		
	zenity --text-info \
		--title="Sovran_SystemsOS Updater" \
		--width=1000 \
		--height=700

	if [[ $? -eq 1 ]]; then
		
		exit 1

	else
	
		if ! ssh root@localhost 'flatpak update -y |

			zenity --progress \
				--no-cancel \
				--auto-close \
				--pulsate \
				--width=500 \
				--text="Updating Flatpaks" \
				--title="Sovran_SystemsOS Updater"'; then
				
				echo "Could Not Update Flatpaks -- Exiting" |
				
					zenity --text-info \
						--width=400 \
						--title="Sovran_SystemsOS Updater"
			exit 1

		fi	

		if ! xterm -fa 'Noto Mono' -fs 15 -fg white -bg black -e bash -c "ssh root@localhost 'cd /etc/nixos && nix flake update && nixos-rebuild switch --impure'"; then
			
			echo "Could Not Update Sovran_SystemsOS -- Exiting" |
				
				zenity --text-info \
					--width=400 \
					--title="Sovran_SystemsOS Updater"

		exit 1

		fi

		zenity --info \
			--ellipsize \
			--no-wrap \
			--width=400 \
			--title="Sovran_SystemsOS Updater" \
			--text="Yay Complete! Please Reboot When You Are Ready."
	fi

exit 0